MsWksDBParser Class Reference documentation

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
MsWksDBParser Class Reference

the main class to read a Microsoft Works database file and convert it in a spreadsheet file More...

`#include <MsWksDBParser.hxx>`

Inheritance diagram for MsWksDBParser:

## Public Member Functions
| MsWksDBParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~MsWksDBParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGSpreadsheetInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWSpreadsheetParser
virtual | ~MWAWSpreadsheetParser ()
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGSpreadsheetInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readDataBase ()
| try to read the database zone More...
bool | sendDatabase ()
| try to send the main database More...
bool | readFieldTypes ()
| reads the list of the fields type v3-v4 More...
bool | readFieldTypesV2 ()
| reads the list of the fields type v2 More...
bool | readRecords (bool onlyCheck)
| reads the database contents: field's names and values More...
bool | readFilters ()
| reads the filters More...
bool | readColSize (std::vector< int > &colSize)
| reads the list of the columns size More...
bool | readDefaultValues ()
| reads the default value More...
bool | readFormula ()
| reads the formula value More...
bool | readSerialFormula ()
| reads the serial value More...
bool | readForms ()
| reads all the form More...
bool | readFormV2 ()
| reads a list of dimension(?) corresponding to the fields type v2 More...
bool | readForm ()
| reads one form More...
bool | readFormTypes (MsWksDBParserInternal::Form &form)
| read a form types More...
bool | readReports ()
| reads the reports More...
bool | readReportHeader ()
| read a report header More...
bool | readReportV2 ()
| reads a report zone in v.2 file More...
bool | readUnknownV2 ()
| reads an unknown zone V2 More...
Protected Member Functions inherited from MWAWSpreadsheetParser
| MWAWSpreadsheetParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWSpreadsheetParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< MsWksDBParserInternal::State > | m_state
| the state More...
std::vector< MWAWEntry > | m_listZones
| the list of different Zones More...
shared_ptr< MsWksDocument > | m_document
| the actual zone More...

## Friends
class | MsWksDBParserInternal::SubDocument

## Detailed Description

the main class to read a Microsoft Works database file and convert it in a spreadsheet file

## Constructor & Destructor Documentation

MsWksDBParser::MsWksDBParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

MsWksDBParser::~MsWksDBParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

bool MsWksDBParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

void MsWksDBParser::createDocument | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

bool MsWksDBParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

void MsWksDBParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by MsWksDBParser().

void MsWksDBParser::parse | ( | librevenge::RVNGSpreadsheetInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWSpreadsheetParser.

bool MsWksDBParser::readColSize | ( | std::vector< int > & | colSize | ) |
| protected

reads the list of the columns size

Referenced by readForms(), readFormV2(), and readReportV2().

bool MsWksDBParser::readDataBase | ( |  | ) |
| protected

try to read the database zone

Referenced by createZones().

bool MsWksDBParser::readDefaultValues | ( |  | ) |
| protected

reads the default value

Referenced by readDataBase().

bool MsWksDBParser::readFieldTypes | ( |  | ) |
| protected

reads the list of the fields type v3-v4

Referenced by readDataBase().

bool MsWksDBParser::readFieldTypesV2 | ( |  | ) |
| protected

reads the list of the fields type v2

Referenced by readDataBase().

bool MsWksDBParser::readFilters | ( |  | ) |
| protected

reads the filters

Referenced by readDataBase().

bool MsWksDBParser::readForm | ( |  | ) |
| protected

reads one form

Referenced by readForms().

bool MsWksDBParser::readForms | ( |  | ) |
| protected

reads all the form

Referenced by createZones(), and readReports().

bool MsWksDBParser::readFormTypes | ( | MsWksDBParserInternal::Form & | form | ) |
| protected

read a form types

[ff,5c,_,-8,_,-9] or [ff,a8,_,-8,_,-9] or [_,5c,_,-8,_,-9]

Referenced by readForm().

bool MsWksDBParser::readFormula | ( |  | ) |
| protected

reads the formula value

Referenced by readDataBase().

bool MsWksDBParser::readFormV2 | ( |  | ) |
| protected

reads a list of dimension(?) corresponding to the fields type v2

Referenced by readDataBase().

bool MsWksDBParser::readRecords | ( | bool | onlyCheck | ) |
| protected

reads the database contents: field's names and values

Note
  if onlyCheck = true, only check if the zone is ok but do nothing

Referenced by readDataBase().

bool MsWksDBParser::readReportHeader | ( |  | ) |
| protected

read a report header

Referenced by readReports().

bool MsWksDBParser::readReports | ( |  | ) |
| protected

reads the reports

Referenced by createZones().

bool MsWksDBParser::readReportV2 | ( |  | ) |
| protected

reads a report zone in v.2 file

Referenced by readDataBase().

bool MsWksDBParser::readSerialFormula | ( |  | ) |
| protected

reads the serial value

reads the serial formula

Referenced by readDataBase().

bool MsWksDBParser::readUnknownV2 | ( |  | ) |
| protected

reads an unknown zone V2

Note
  this header looks like the form v3-4 header, but is it really the form header ?

Referenced by readDataBase().

bool MsWksDBParser::sendDatabase | ( |  | ) |
| protected

try to send the main database

Referenced by parse().

## Friends And Related Function Documentation

friend class MsWksDBParserInternal::SubDocument
| friend

## Member Data Documentation

shared_ptr<MsWksDocument> MsWksDBParser::m_document
| protected

the actual zone

Referenced by checkHeader(), createDocument(), createZones(), MsWksDBParser(), parse(), readColSize(), readDataBase(), readDefaultValues(), readFieldTypes(), readFieldTypesV2(), readFilters(), readForm(), readForms(), readFormTypes(), readFormula(), readFormV2(), readRecords(), readReportHeader(), readReports(), readReportV2(), readSerialFormula(), readUnknownV2(), and sendDatabase().

std::vector<MWAWEntry> MsWksDBParser::m_listZones
| protected

the list of different Zones

shared_ptr<MsWksDBParserInternal::State> MsWksDBParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), readDataBase(), readDefaultValues(), readFieldTypes(), readFieldTypesV2(), readForm(), readForms(), readFormTypes(), readFormula(), readFormV2(), readRecords(), readReports(), readSerialFormula(), and sendDatabase().

The documentation for this class was generated from the following files:

- MsWksDBParser.hxx
- MsWksDBParser.cxx